
#cs

Middlesizer v0.1

Win + forward-slash (Win + /) = maximise active window's width/height
Win + fullstop (Win + .) = maximise active window's width/height to 90%
Win + comma (Win + ,) repeatedly = centre active window vertically/horizotally at roughly 4/3, 1/1 and 3/4 the screen width/height (press multiple times to cycle)

This utility was written for my 1080x1920 monitor (which is very tall, in other words), so that I could easily resize windows to more appropriate sizes.

Additional: Win left and Win right puts active window flush with left and right screen edge

#ce

Global $screenwidth
Global $oldposition
Global $screenheight
Global $winwidth
Global $winheight
Global $topleftx
Global $toplefty
Global $activewindowtitle
Global $j = 1
Global $windowstaskbar
Global $windowstaskbarheight

If @DesktopWidth < @DesktopHeight Then ; portrait
MsgBox (0, "Middlesizer v.01, portrait mode", "Middlesizer will operate in portrait mode" & @CRLF & @CRLF & "Win + / = maximise active window's width" & @CRLF & "Win + . = maximise active window's width to 90%" & @CRLF & "Win + , repeatedly = centre active window vertically, and resize to roughly" & @CRLF & " 4/3, 1/1 and 3/4 the screen height (press multiple times to cycle)", 0)
HotKeySet("#,", "tallcycle")
HotKeySet("#.", "horcentre")
HotKeySet("#/", "hormax")
ElseIf @DesktopWidth > @DesktopHeight Then ; landscape
MsgBox (0, "Middlesizer v.01, landscape mode", "Middlesizer will operate in landscape mode" & @CRLF & @CRLF & "Win + / = maximise active window's height" & @CRLF & "Win + . = maximise active window's height to 90%" & @CRLF & "Win + , repeatedly = centre active window horizontally, and resize to roughly" & @CRLF & " 4/3, 1/1 and 3/4 the screen width (press multiple times to cycle)", 0)
HotKeySet("#,", "widecycle")
HotKeySet("#.", "vercentre")
HotKeySet("#/", "vermax")
EndIf

#cs
HotKeySet("#{left}", "hugleft")
HotKeySet("#{right}", "hugright")
HotKeySet("#{up}", "hugtop")
HotKeySet("#{down}", "hugbottom")
#ce

While 1
    Sleep(100)
WEnd

; =================================================

Func widecycle()

$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
$windowstaskbarheight = $windowstaskbar[3]

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenwidth = @DesktopWidth
$screenheight = @DesktopHeight - $windowstaskbarheight
$winheight = $oldposition[3]

If $j = 1 Then
$winwidth = $screenheight * 3/4
ElseIf $j = 2 Then
$winwidth = $screenheight * 4/4
ElseIf $j = 3 Then
$winwidth = $screenheight * 4/3
EndIf

$toplefty = $oldposition[1]
$topleftx = ($screenwidth / 2) - ($winwidth / 2)
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

If $j = 3 Then
$j = 1
Else
$j = $j + 1
EndIf

EndFunc

Func vercentre()

$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
$windowstaskbarheight = $windowstaskbar[3]

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenheight = @DesktopHeight - $windowstaskbarheight
$winheight = $screenheight * 0.9

$topleftx = $oldposition[0]
$toplefty = @DesktopHeight * 0.05 ; note deviation here
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $oldposition[2], $winheight, 1)

EndFunc

Func vermax()

$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
$windowstaskbarheight = $windowstaskbar[3]

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenheight = @DesktopHeight - $windowstaskbarheight
$winheight = $screenheight

$topleftx = $oldposition[0]
$toplefty = 0
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $oldposition[2], $winheight, 1)

EndFunc

; =================================================


Func tallcycle()

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenwidth = @DesktopWidth
$screenheight = @DesktopHeight
$winwidth = $oldposition[2]

If $j = 1 Then
$winheight = $screenwidth * 3/4
ElseIf $j = 2 Then
$winheight = $screenwidth * 1
ElseIf $j = 3 Then
$winheight = $screenwidth * 4/3
EndIf

$topleftx = $oldposition[0]
$toplefty = ($screenheight / 2) - ($winheight / 2)
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

If $j = 3 Then
$j = 1
Else
$j = $j + 1
EndIf

EndFunc

Func horcentre()

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenwidth = @DesktopWidth
$winwidth = $screenwidth * 0.9

$topleftx = $screenwidth * 0.05
$toplefty = $oldposition[1]
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $oldposition[3], 1)

EndFunc

Func hormax()

$activewindowtitle = WinGetTitle("[active]")
$oldposition = WinGetPos ($activewindowtitle, "")

$screenwidth = @DesktopWidth
$winwidth = $screenwidth

$topleftx = 0
$toplefty = $oldposition[1]
WinMove ($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $oldposition[3], 1)

EndFunc

