
#cs
	Middlesizer v0.2
#ce

Global $screenwidth
Global $oldposition
Global $screenheight
Global $winwidth
Global $winheight
Global $topleftx
Global $toplefty
Global $activewindowtitle
Global $activewindowtitleMIN
Global $j = 1
Global $k = 1
Global $l = 1
Global $m = 1
Global $windowstaskbar
Global $windowstaskbarheight

; First, determine whether user has portrait or landscape monitor, and
; enable shortcuts accordingly

If @DesktopWidth < @DesktopHeight Then ; portrait
	MsgBox(0, "Middlesizer v.02, portrait mode", "Middlesizer will operate in portrait mode" & @CRLF & @CRLF & "Press Win + Shift + questionmark to see the shortcuts again" & @CRLF & @CRLF & "Win + / = move active window to 33%, 50% and 66% of screen height" & @CRLF & "Win + . = resize active window to 90% and 100% of screen width" & @CRLF & "Win + , = centre active window vertically, and resize to roughly" & @CRLF & " 4/3, 1/1 and 3/4 the screen height" & @CRLF & @CRLF & "Win + m = minimise all windows (this is a normal Windows function)" & @CRLF & "Win + n = minimise active window only" & @CRLF & @CRLF & "Win + up = move active window to just above screen's middle" & @CRLF & "Win + down = move active window to just below screen's middle", 0)
	HotKeySet("#,", "centreandresize")
	HotKeySet("#.", "widthresize")
	HotKeySet("#/", "movethreepositions")
	HotKeySet("#{UP}", "sitabove")
	HotKeySet("#{DOWN}", "sitbelow")
	HotKeySet("#+/", "shortcuts") ; this is a question mark

ElseIf @DesktopWidth > @DesktopHeight Then ; landscape
	MsgBox(0, "Middlesizer v.01, landscape mode", "Middlesizer will operate in landscape mode" & @CRLF & @CRLF & "Win + / = maximise active window's height" & @CRLF & "Win + . = maximise active window's height to 90%" & @CRLF & "Win + , repeatedly = centre active window horizontally, and resize to roughly" & @CRLF & " 4/3, 1/1 and 3/4 the screen width (press multiple times to cycle)" & CRLF & CRLF "Win + n = minimise the current window", 0)
	HotKeySet("#,", "widecycle")
	HotKeySet("#.", "vercentre")
	HotKeySet("#/", "vermax")
EndIf

HotKeySet("#n", "mincurr")
; I can't get the restore function to work
; HotKeySet("#b", "unmincurr")

While 1
	Sleep(100)
WEnd

; ===============================================
; MIMIMISE CURRENT, AND RESTORE IT LATER
; I can't get the restore function to work
; The same functions are used for portrait and landscape modes

Func mincurr()
	$m = 0 ; actually, this variable is used only if Win + b is used
	$activewindowtitleMIN = WinGetTitle("[active]")
	WinSetState($activewindowtitleMIN, "", @SW_MINIMIZE)
EndFunc   ;==>mincurr

#cs
	; I can't get the restore function to work
	Func unmincurr()
	If $m = 0 Then
	WinSetState ($activewindowtitleMIN, "", @SW_RESTORE)
	$m = 1
	EndIf
	EndFunc
#ce

; =================================================
; LANDSCAPE FUNCTIONS

Func widecycle()

	$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
	$windowstaskbarheight = $windowstaskbar[3]

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$screenwidth = @DesktopWidth
	$screenheight = @DesktopHeight - $windowstaskbarheight
	$winheight = $oldposition[3]

	If $j = 1 Then
		$winwidth = $screenheight * 3 / 4
	ElseIf $j = 2 Then
		$winwidth = $screenheight * 4 / 4
	ElseIf $j = 3 Then
		$winwidth = $screenheight * 4 / 3
	EndIf

	$toplefty = $oldposition[1]
	$topleftx = ($screenwidth / 2) - ($winwidth / 2)
	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

	If $j = 3 Then
		$j = 1
	Else
		$j = $j + 1
	EndIf

EndFunc   ;==>widecycle

Func vercentre()

	$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
	$windowstaskbarheight = $windowstaskbar[3]

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$screenheight = @DesktopHeight - $windowstaskbarheight
	$winheight = $screenheight * 0.9

	$topleftx = $oldposition[0]
	$toplefty = @DesktopHeight * 0.05 ; note deviation here
	WinMove($activewindowtitle, "", $topleftx, $toplefty, $oldposition[2], $winheight, 1)

EndFunc   ;==>vercentre

Func vermax()

	$windowstaskbar = WinGetPos("[CLASS:Shell_TrayWnd]")
	$windowstaskbarheight = $windowstaskbar[3]

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$screenheight = @DesktopHeight - $windowstaskbarheight
	$winheight = $screenheight

	$topleftx = $oldposition[0]
	$toplefty = 0
	WinMove($activewindowtitle, "", $topleftx, $toplefty, $oldposition[2], $winheight, 1)

EndFunc   ;==>vermax

; =================================================
; PORTRAIT FUNCTIONS
; There are currently more portrait functions than landscape functions
; because the portrait mode was rewritten, but the landscape mode wasn't.

Func centreandresize()

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$screenwidth = @DesktopWidth
	$screenheight = @DesktopHeight
	$winwidth = $oldposition[2]

	If $j = 1 Then
		$winheight = $screenwidth * 3 / 4
	ElseIf $j = 2 Then
		$winheight = $screenwidth * 1
	ElseIf $j = 3 Then
		$winheight = $screenwidth * 4 / 3
	EndIf

	$topleftx = $oldposition[0]
	$toplefty = ($screenheight / 2) - ($winheight / 2)
	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

	If $j = 3 Then
		$j = 1
	Else
		$j = $j + 1
	EndIf

EndFunc   ;==>centreandresize

Func widthresize()

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	If $k = 1 Then
		$screenwidth = @DesktopWidth
		$winwidth = $screenwidth * 0.9
		$topleftx = $screenwidth * 0.05
		$toplefty = $oldposition[1]
	ElseIf $k = 2 Then
		$screenwidth = @DesktopWidth
		$winwidth = $screenwidth
		$topleftx = 0
		$toplefty = $oldposition[1]
		#cs
			; Personally I don't think a 70% width is useful, so I removed it
			ElseIf $k = 3 Then
			$screenwidth = @DesktopWidth
			$winwidth = $screenwidth * 0.7
			$topleftx = $screenwidth * 0.15
			$toplefty = $oldposition[1]
		#ce
	EndIf

	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $oldposition[3], 1)

	If $k = 2 Then
		; If $k = 3 Then ; for use if you have 3 "k" cycles above instead of just 2
		$k = 1
	Else
		$k = $k + 1
	EndIf

EndFunc   ;==>widthresize

Func movethreepositions()

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	If $l = 1 Then
		$screenheight = @DesktopHeight
		$topleftx = $oldposition[0]
		$toplefty = $screenheight * 0.33 - ($oldposition[3] / 2)
		$winwidth = $oldposition[2]
		$winheight = $oldposition[3]

	ElseIf $l = 2 Then
		$screenheight = @DesktopHeight
		$topleftx = $oldposition[0]
		$toplefty = $screenheight * 0.50 - ($oldposition[3] / 2)
		$winwidth = $oldposition[2]
		$winheight = $oldposition[3]

	ElseIf $l = 3 Then
		$screenheight = @DesktopHeight
		$topleftx = $oldposition[0]
		$toplefty = $screenheight * 0.66 - ($oldposition[3] / 2)
		$winwidth = $oldposition[2]
		$winheight = $oldposition[3]

	EndIf

	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

	If $l = 3 Then
		$l = 1
	Else
		$l = $l + 1
	EndIf

EndFunc   ;==>movethreepositions

Func sitabove()

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$topleftx = $oldposition[0]
	$toplefty = (@DesktopHeight / 2) - $oldposition[3]
	$winwidth = $oldposition[2]
	$winheight = $oldposition[3]

	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

EndFunc   ;==>sitabove

Func sitbelow()

	$activewindowtitle = WinGetTitle("[active]")
	$oldposition = WinGetPos($activewindowtitle, "")

	$topleftx = $oldposition[0]
	$toplefty = (@DesktopHeight / 2)
	$winwidth = $oldposition[2]
	$winheight = $oldposition[3]

	WinMove($activewindowtitle, "", $topleftx, $toplefty, $winwidth, $winheight, 1)

EndFunc   ;==>sitbelow

Func shortcuts()
	; The traytip has a certain maximim size, hence the crypticness

	TrayTip("Middlesizer v.01, portrait mode", "Win + / = move, 33%, 50% and 66% of height" & @CRLF & "Win + . = resize, 90% or 100% of width" & @CRLF & "Win + , = move & resize, 4:3, 1:1 and 3:4" & @CRLF & "Win + up = move to above centre" & @CRLF & "Win + down = move to below centre", 10)

EndFunc   ;==>shortcuts


